﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.ServiceModel.Activation;
using Syncfusion.JavaScript.Olap;
using System.Web.Script.Serialization;
using System.Web;
using Syncfusion.Olap.Manager;
using System.Data.SqlServerCe;
using System.Data;
using System.IO;
using Syncfusion.Olap.Reports;
using Syncfusion.PivotAnalysis.Base;
using Syncfusion.Olap.Common;
using Syncfusion.JavaScript;

namespace WebApplication44.wcf
{
    class OrderDetails
    {
        private SqlCeConnection con;
        public static DataView GetOrderDetials()
        {
            try
            {
                DataSet ds = new DataSet();
                //In below provide full path of your database(*.sdf) location.
                string conStringforDB = HttpContext.Current.Server.MapPath("Northwind.sdf").Split(new string[] { "\\wcf" }, StringSplitOptions.None)[0] + "\\Northwind.sdf";
                SqlCeConnection con = new SqlCeConnection(conStringforDB);
                
                    con.Open();
                    SqlCeCommand cmd = new SqlCeCommand(@"SELECT Top(100) [Order ID], [Product ID], [Unit Price], Quantity
                                                          FROM [Order Details] ", con);
                    SqlCeDataAdapter da = new SqlCeDataAdapter(cmd);


                    da.Fill(ds);

                    //Creation of DataView
                    DataView dataView = new DataView(ds.Tables[0]);
                    return dataView;
                


            }
            catch (Exception e)
            {
                return null;
            }
        }
    }
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "PivotService" in code, svc and config file together.
    [AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
    public class RelationalService : IRelationalService
    {
        PivotGrid htmlHelper = new PivotGrid();
        JavaScriptSerializer serializer = new JavaScriptSerializer();
        Dictionary<string, object> dict = new Dictionary<string, object>();

        public Dictionary<string, object> InitializeGrid(string action)
        {
            htmlHelper.PivotReport = BindDefaultData();
            dict = htmlHelper.GetJsonData(action, OrderDetails.GetOrderDetials());
            return dict;
        }


        public Dictionary<string, object> FetchMembers(string action, string headerTag, string sortedHeaders, string currentReport)
        {
            htmlHelper.PopulateData(currentReport);
            dict = htmlHelper.GetJsonData(action, OrderDetails.GetOrderDetials(), headerTag, sortedHeaders);
            return dict;
        }

        public Dictionary<string, object> Filtering(string action, string filterParams, string sortedHeaders, string currentReport)
        {
            htmlHelper.PopulateData(currentReport);
            dict = htmlHelper.GetJsonData(action, OrderDetails.GetOrderDetials(), filterParams, sortedHeaders);
            return dict;
        }

        public Dictionary<string, object> NodeStateModified(string action, string headerTag, string dropAxis, string sortedHeaders, string filterParams, string currentReport)
        {
            htmlHelper.PopulateData(currentReport);
            dict = htmlHelper.GetJsonData(action, OrderDetails.GetOrderDetials(), headerTag, dropAxis, filterParams, sortedHeaders);
            return dict;
        }

        public Dictionary<string, object> NodeDropped(string action, string dropAxis, string headerTag, string sortedHeaders, string filterParams, string currentReport)
        {
            htmlHelper.PopulateData(currentReport);
            dict = htmlHelper.GetJsonData(action, OrderDetails.GetOrderDetials(), dropAxis, headerTag, filterParams, sortedHeaders);
            return dict;
        }
        public Dictionary<string, object> Sorting(string action, string sortedHeaders, string currentReport)
        {
            htmlHelper.PopulateData(currentReport);
            dict = htmlHelper.GetJsonData(action, OrderDetails.GetOrderDetials(), sortedHeaders);
            return dict;
        }

        private PivotReport BindDefaultData()
        {
            PivotReport pivotSetting = new PivotReport();
            pivotSetting.PivotColumns.Add(new PivotItem { FieldHeader = "OrderID", FieldMappingName = "Order ID", TotalHeader = "Total" });
            pivotSetting.PivotRows.Add(new PivotItem { FieldHeader = "ProductID", FieldMappingName = "Product ID", TotalHeader = "Total" });
            pivotSetting.PivotCalculations.Add(new PivotComputationInfo { CalculationName = "UnitPrice", FieldName = "Unit Price", Format = "C" });
            pivotSetting.PivotCalculations.Add(new PivotComputationInfo { CalculationName = "Quantity", FieldName = "Quantity" });
            return pivotSetting;
        }
    }
}
